/*！
 * 调起第三方支付 1 JavaScript
 * liezu - v1.0(2016-09-21)
 * 
 */


var pays = {};//支付通道
function plusReady() {
	// 获取支付通道
	plus.payment.getChannels(function(channels) {
		var txt = "支付通道信息：";
		for (var i in channels) {
			var channel = channels[i];
			pays[channel.id] = channel;
			txt += "id:" + channel.id + ", ";
			txt += "description:" + channel.description + ", ";
			txt += "serviceReady:" + channel.serviceReady + "； ";
			checkServices(channel);
//			console.log(txt);
		}
	}, function(e) {
		outLine("获取支付通道失败：" + e.message);
	});
}

/**
 * 初始化页面
 */
document.addEventListener('plusready', plusReady, false);

/**
 * 检测是否安装通道
 * @param {Object} pc 通道类型
 */
function checkServices(pc) {  
	if (!pc.serviceReady) {
		var txt = null;
		switch (pc.id) {
			case "alipay":
				txt = "检测到系统未安装“支付宝快捷支付服务”，无法完成支付操作，是否立即安装？";
				break;
			default:
				txt = "系统未安装“" + pc.description + "”服务，无法完成支付，是否立即安装？";
				break;
		}
		plus.nativeUI.confirm(txt, function(e) {
			if (e.index == 0) {
				pc.installService();
			}
		}, pc.description);
	}
}

var w =null;
/**
 * 调起支付
 * @param {String} orderid 支付订单号
 * @param {Object} allFare 支付金额
 * @param {Object} payment 支付通道/支付方式
 */
function pay(orderid,allFare,payment) {
	if(allFare<=0 || !allFare){return ;}
//	allFare = 0.01;//测试金额，上线后删除本条
	var wxpayUrl = WebRoot + 'pay/wxpay/wxpay.php?orderid=' + orderid + '&total='+allFare;
	var alipayUrl = WebRoot + 'pay/alipay/alipay.php?orderid=' + orderid + '&total='+allFare;
	var url = '';
	if (payment == 'wxpay') {
		url = wxpayUrl;
	} else if (payment == 'alipay') {
		url = alipayUrl;
	}
	if (w) { 
		return;
	} //检查是否请求订单中
	console.log(url);
	w = plus.nativeUI.showWaiting('请求支付中...',{width:'100px',height:'100px',background:'rgba(0,0,0,0.3)'});
	// 请求支付订单
	var xhr = new XMLHttpRequest();
	xhr.onreadystatechange = function() {
		switch (xhr.readyState) {
			case 4:
				w.close();
				w = null;
				if (xhr.status == 200) {
					var order = xhr.responseText;
					console.log(order);
					plus.payment.request(pays[payment], order, function(result) {
//						plus.nativeUI.alert("支付成功", function() {
//							plus.webview.currentWebview().close('none');
//						}, "支付");
						payOrder(orderid,(result.tradeno && result.tradeno!=undefined ? result.tradeno : ''),payment,allFare);
					}, function(e) {
						plus.nativeUI.alert("提示", null, "未支付");
						console.log("["+e.code+"]："+e.message);
					});
				} else {
					plus.nativeUI.alert("获取订单信息失败！", null, "支付");
				}
				break;
			default:
				break;
		}
	}
	xhr.open('GET', url);
	xhr.send();
}

/**
 * 支付成功，后台订单状态修改
 * @param {Object} orderid 支付订单号
 * @param {Object} tradeno 支付交易号
 * @param {Object} payment 支付通道
 * @param {Object} allFare 支付金额
 */
function payOrder(orderid,tradeno,payment,allFare){
	$.ajax({
		type:"get",
		url:ApiRoot,
		dataType:'json',
		data:'m=member&a=payOrder&orderid='+orderid+'&payment='+payment+'&payMoney='+allFare+'&tradeno='+tradeno,
		success:function(data){
			plus.nativeUI.closeWaiting();
			console.log(JSON.stringify(data));
			if(data>=0){
				toast('支付成功');
				$('#payOrder').addClass('mui-hidden');
				getOrderDetail();
				uodate_order_list();
			}
		},
		error:function(e){
			plus.nativeUI.closeWaiting();
			console.log(JSON.stringify(e));
			toast('失去网络连接');
		}
	});
}

/**
 * 使用平台币(余额)支付
 * @param {Object} orderid 支付订单号
 * @param {Object} total 支付金额
 * @param {Object} payment 支付通道balance
 */
function payByBalance(orderid,total,payment) {
	var userid = plus.storage.getItem('ktv_userid');
	var ws = plus.webview.currentWebview();
	var oid = ws.oid;
	plus.nativeUI.confirm("确定使用余额支付吗？", function(e) {
		if (e.index == 0) {
			plus.nativeUI.showWaiting('支付中...');
			$.ajax({
				type: "get",
				url: ApiRoot,
				dataType: 'json',
				data: 'm=member&a=payByBalance&orderid=' + orderid + "&total=" + total,
				success: function(data) {
					plus.nativeUI.closeWaiting();
					if (data) {
						if (data == -1) {
							plus.nativeUI.toast("余额不足");
							plus.nativeUI.closeWaiting();
						} else {
							toast('支付成功');
							getMyOrders();
						}
					} else {
						plus.nativeUI.alert("支付失败，请检查网络");
					}
				}
			});
		}
	}, "余额支付", ["确定", "取消"]);
}