/*！
 * 第三方软件分享 1 JavaScript
 * liezu - v1.0(2016-09-21)
 * 
 */

var shares = {};		// 分享通道
/**
 * 初始化页面
 */
document.addEventListener('plusready',function(){
	plus.share.getServices( function(s){
		shares={};
		for(var i in s){
			var t=s[i];
			shares[t.id]=t;
		}
//		console.log(JSON.stringify(shares))
	}, function(e){
		console.log( "获取分享服务列表失败："+e.message );
	} );
},false);

/**
 * 选择分享通道/方式
 */
function shareActionSheet(){
	shock();
	var ids=[{id:"weixin",ex:"WXSceneSession"},{id:"weixin",ex:"WXSceneTimeline"},{id:"sinaweibo"},{id:"qq"}],
	bts=[{title:"发送给微信好友"},{title:"分享到微信朋友圈"},{title:"分享到新浪微博"},{title:"分享到QQ好友"}];
	plus.nativeUI.actionSheet({cancel:"取消",buttons:bts},
		function(e){
			var i=e.index;
			if(i>0){
				$(".show-por").hide();
				var s = shares[ids[i-1].id];
				if ( s.authenticated ) {
					console.log('授权成功');
					shareMessage(shares[ids[i-1].id],ids[i-1].ex);
				} else {
					console.log('尚未授权，授权中...');
					s.authorize( function(){
							console.log('授权成功');
							shareMessage(shares[ids[i-1].id],ids[i-1].ex);
						},function(e){
						console.log( "认证授权失败"+e.message,null,'提示' );
					});
				}
			}
		}
	);
}
/**
 * 查看是否授权
 * @param {Object} id 分享通道ID
 * @param {Object} ex 分享通道ID分类
 */
function shareAction(id, ex){
	plus.nativeUI.confirm('确认要分享到'+(id=='qq' ? 'QQ平台' : (id=='weixin' ? '微信平台' : '新浪微博'))+'吗？',function(e){
		if(e.index==0){
			showWaiting('正在分享');
			var s = shares[id];
			if ( s.authenticated ) {
				plus.nativeUI.closeWaiting();	
				console.log('授权成功');
				shareMessage(shares[id],ex);
			} else {
				console.log('尚未授权，授权中...');
				s.authorize( function(){
						plus.nativeUI.closeWaiting();	
						console.log('授权成功');
						shareMessage(shares[id],ex);
					},function(e){
					plus.nativeUI.closeWaiting();	
					console.log( "认证授权失败"+e.message,null,'提示' );
				});
			}
		}
	},'提示',['确定','取消']);
}

/**
 * 调起分享
 * @param {Object} s 分享通道ID
 * @param {Object} ex 分享通道ID分类
 */
function shareMessage(s, ex) { 
	showWaiting('正在分享');
	var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
		msg.title = '猎租APP';
		msg.href='http://apk.hiapk.com/appinfo/com.hanghang.liezu';
		msg.thumbs=["../img/logo.png"];
	s.send( msg, function(){
		plus.nativeUI.closeWaiting();
		toast( "分享到\""+s.description+"\"成功！ " );
	}, function(e){
		console.log(JSON.stringify(e));
		plus.nativeUI.closeWaiting();
		toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
		console.log("分享失败！"+e.message);
	} );	
}



/**
 * 分享APP
 */
function shareActionSheetToFriend(fid, avatar ,name){
	shock();
	var ids=[{id:"weixin",ex:"WXSceneSession"},{id:"weixin",ex:"WXSceneTimeline"},{id:"sinaweibo"},{id:"qq"}],
	bts=[{title:"发送给微信好友"},{title:"分享到微信朋友圈"},{title:"分享到新浪微博"},{title:"分享到QQ好友"}];
	plus.nativeUI.actionSheet({cancel:"取消",buttons:bts},
		function(e){
			var i=e.index;
			if(i>0){
				$(".show-por").hide();
				var s = shares[ids[i-1].id];
				if ( s.authenticated ) {
					console.log('授权成功');
					shareMessageFriend(shares[ids[i-1].id],ids[i-1].ex, fid, avatar,name);
				} else {
					console.log('尚未授权，授权中...');
					s.authorize( function(){
							console.log('授权成功');
							shareMessageFriend(shares[ids[i-1].id],ids[i-1].ex, fid, avatar,name);
						},function(e){
						console.log( "认证授权失败"+e.message,null,'提示' );
					});
				}
			}
		}
	);
}
/**
 * 调起分享
 * @param {Object} s 分享通道ID
 * @param {Object} ex 分享通道ID分类
 */
function shareMessageFriend(s, ex, fid, avatar, name) { 
	console.log('avatar:'+avatar+typeof(avatar));
	showWaiting('正在分享');
	if(!avatar || avatar=='' || avatar=='null'){
		var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
			msg.title = '猎租分享';
			msg.href=WebRoot+'index.php?a=mylease&leaseid='+fid;
			var a = savepath;
			if(s.id!='sinaweibo'){
				msg.thumbs=['../img/avatar_gray.png'];
			}else{
				msg.pictures=['../img/avatar_gray.png'];
			}
		s.send( msg, function(){ 
			plus.nativeUI.closeWaiting();
			toast( "分享到\""+s.description+"\"成功！ " );
		}, function(e){
			console.log(JSON.stringify(e));
			plus.nativeUI.closeWaiting();
			toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
			console.log("分享失败！"+e.message); 
		} );
		return ;
	}
	if(avatar && avatar.indexOf('qlogo.cn')>0){
		var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
			msg.title = '猎租分享';
			msg.href=WebRoot+'index.php?a=mylease&leaseid='+fid;
			var a = savepath;
			if(s.id!='sinaweibo'){
				msg.thumbs=[avatar];
			}else{
				msg.pictures=[avatar];
			}
		s.send( msg, function(){ 
			plus.nativeUI.closeWaiting(); 
			toast( "分享到\""+s.description+"\"成功！ " );
		}, function(e){
			console.log(JSON.stringify(e));
			plus.nativeUI.closeWaiting();
			toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
			console.log("分享失败！"+e.message); 
		} );
		return ;
	}
	var url = avatar;
	var filename = url.substr(url.lastIndexOf('/')+1);
	var savepath = '_downloads/share/'+filename;
	// 打开doc根目录
	plus.io.requestFileSystem( plus.io.PUBLIC_DOWNLOADS, function(fs){
		fs.root.getDirectory( 'share', {create:true}, function(entry){
			var dir = entry;
			dir.getFile( filename, {create:false}, function(fentry){
				var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
					msg.title = '猎租分享';
					msg.href=WebRoot+'index.php?a=mylease&leaseid='+fid;
					var a = savepath;
					if(s.id!='sinaweibo'){
						msg.thumbs=[a];
					}else{
						msg.pictures=[a];
					}
					console.log('filename:'+filename);
				s.send( msg, function(){ 
					plus.nativeUI.closeWaiting();
					toast( "分享到\""+s.description+"\"成功！ " );
				}, function(e){
					console.log(JSON.stringify(e));
					plus.nativeUI.closeWaiting();
					toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
					console.log("分享失败！"+e.message); 
				} );
			}, function(e){
				console.log('文件不存在，从服务器获取升级数据');
				downloadAvatar(s, ex, fid, avatar, name);
			});
			
		}, function(e){
			console.log( "准备升级操作，打开update目录失败："+e.message );
		});
	},function(e){
		console.log( "准备升级操作，打开doc目录失败："+e.message );
	});
	
}

function downloadAvatar(s, ex, fid, avatar, name){
	var url = avatar;
	var downloadPath = getImgUrl(avatar);
	console.log('downloadPath:'+downloadPath);
	var filename = url.substr(url.lastIndexOf('/')+1);
	var savepath = '_downloads/share/'+filename;
	var dtask = plus.downloader.createDownload( downloadPath, {filename:savepath}, function ( d, status ) {
		// 下载完成
		if ( status == 200 ) { 
			console.log( "Download success: " + d.filename );
			var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
				msg.title = '猎租分享';
				msg.href=WebRoot+'index.php?a=mylease&leaseid='+fid;
				if(s.id!='sinaweibo'){
					msg.thumbs=[savepath];
				}else{
					msg.pictures=[savepath];
				}
				console.log('filename:'+filename);
			s.send( msg, function(){ 
				plus.nativeUI.closeWaiting();
				toast( "分享到\""+s.description+"\"成功！ " );
			}, function(e){
				console.log(JSON.stringify(e));
				plus.nativeUI.closeWaiting();
				toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
				console.log("分享失败！"+e.message); 
			} );
		} else {
			 console.log( "Download failed: " + status );
			 var msg = {content:'在这里你可以出租自己的空闲时间，也可以邀请他人一起运动，聚会，旅游等合法活动。',extra:{scene:ex}};
				msg.title = '猎租分享';
				msg.href=WebRoot+'index.php?a=mylease&leaseid='+fid;
				if(s.id!='sinaweibo'){
					msg.thumbs=[avatar];
				}else{
					msg.pictures=[avatar];
				}
				console.log('filename:'+filename);
			s.send( msg, function(){ 
				plus.nativeUI.closeWaiting();
				toast( "分享到\""+s.description+"\"成功！ " );
			}, function(e){
				console.log(JSON.stringify(e));
				plus.nativeUI.closeWaiting();
				toast(''+(e.code==-2 ? '您已取消分享' : '分享未成功'));
				console.log("分享失败！"+e.message); 
			} );
		}  
	});
	dtask.start();
}
