/*！
 * chat.html 1 JavaScript
 * liezu - v1.0(2016-09-21)
 * 
 * 群组消息
 */
var ws = null;
var uid = null;
var gid = null;
var page = 0;
var maxid = 0;
var isLoadHistory = 0;

/**
 * 初始化页面
 */
document.addEventListener('plusready',function(){
	ws = plus.webview.currentWebview();
	uid = getStorage('lz_uid');
	gid = ws.gid;
	$("#friendName").text(ws.gname);
	if(!gid){
		toast('未找到好友');
		ws.close('auto',500);
		return ;
	}
	getChatDetail();
	
	$("#msg-list").scroll(function(){
//		console.log($("#msg-list")[0].scrollHeight);
		if(isLoadHistory==0){
			if($(this).scrollTop()==0){
				isLoadHistory=1; 
				$('#loadHistory').show()
				getChatDetailOfHistory();
			}
		}
	})
	
},false);

/**
 * 创建群组详情页面并打开
 */
function goGroupDetail(){
	var w = plus.webview.create('group_info.html','group_info.html',{},{gid:gid});
	w.show('pop-in',500);
}

/**
 * 获取最新消息
 */
function getChatDetail(){
	if(!uid || !gid){
		return ;
	}
	$.ajax({
		type:"get",
		url:ApiRoot,
		dataType:'json',
		data:'m=chat&a=getChatDetailOfGroup&uid='+uid+'&gid='+gid+'&page='+page,
		success:function(data){
			$('#loadHistory').hide();
			console.log(JSON.stringify(data));  
			var html = getChatHtml(data);
			if(data){
				$("#msg-list").html(html);
				page++;
				messageGoBottom();
				loading();
				getChatingMessage();
			} else{
				$("#msg-list").html('<div class="null-msg">暂无聊天消息</div>'); 
				getChatingMessage();
			}
		},
		error:function(e){
			console.log(JSON.stringify(e));
		} 
	});
	
}
/**
 * 获取历史消息记录
 */
function getChatDetailOfHistory(){
	if(!uid || !gid){
		return ;
	}
	var lastScrollHeight = $("#msg-list")[0].scrollHeight;
	$.ajax({
		type:"get",
		url:ApiRoot,
		dataType:'json',
		data:'m=chat&a=getChatDetailOfGroup&uid='+uid+'&gid='+gid+'&page='+page,
		success:function(data){
//			console.log(JSON.stringify(data));
			if(data){
				var html = getChatHtmlOfHistory(data);
				setTimeout(function(){
					$("#msg-list").prepend(html);
					$('#loadHistory').hide();
					isLoadHistory=0;
					page++;
					loading();
					var div = document.getElementById('msg-list');
					div.scrollTop = $("#msg-list")[0].scrollHeight-lastScrollHeight-50;
//					console.log($("#msg-list").height());
				},1500);
			}else{
				toast('没有更多的历史消息了');
				$('#loadHistory').hide();
			}
		},
		error:function(e){
			console.log(JSON.stringify(e));
		} 
	});
}
/**
 * 将最新消息的json数据拼成html
 * @param {Object} data json数据
 * @return {html} 返回html代码
 */
function getChatHtml(data){
	if(!data || data.length<=0){
		return ;
	}
	var html = '';
	$.each(data, function(k,v) {
		console.log(JSON.stringify(v))
		maxid = v.id;
		var avatar = (v.user && v.user.avatar ? getImgUrl(v.user.avatar) : '../img/avatar_gray.png');
		html += '<div class="msg-item '+(v.uid==uid ? 'msg-item-self' : '')+'" msg-type="'+v.type+'" msg-content="'+(v.type==0 ? v.message : getImgUrl(v.message))+'">';
		html += '<img class="msg-user-img '+(v.uid==uid ? 'self-avatar' : '')+'" src="'+avatar+'" alt="" />';
		html += '<div class="msg-content">';
		html += '<div class="msg-content-inner">';
		if(v.type=='text')html += ''+v.message;
		if(v.type=='image')html += '<img class="msg-content-image" src="'+(v.message ? getImgUrl(v.message) : '')+'" style="max-width: 100px;" />';
		if(v.type=='sound')html += '<span class="mui-icon mui-icon-mic" style="font-size: 18px;font-weight: bold;"></span><span class="play-state">点击播放</span>';
		html += '</div><div class="msg-content-arrow"></div></div>';
		html += '<div class="mui-item-clear"></div></div>';
	});
	return html;	
}
/**
 * 将历史消息的json数据拼成html
 * @param {Object} data json数据
 * @return {html} 返回html代码
 */
function getChatHtmlOfHistory(data){
	if(!data || data.length<=0){
		return ;
	}
	var html = '';
	$.each(data, function(k,v) {
		var avatar = (v.user && v.user.avatar ? getImgUrl(v.user.avatar) : '../img/avatar_gray.png');
		html += '<div class="msg-item '+(v.uid==uid ? 'msg-item-self' : '')+'" msg-type="'+v.type+'" msg-content="'+(v.type==0 ? v.message : getImgUrl(v.message))+'">';
		html += '<img class="msg-user-img '+(v.uid==uid ? 'self-avatar' : '')+'" src="'+avatar+'" alt="" />';
		html += '<div class="msg-content">';
		html += '<div class="msg-content-inner">';
		if(v.type=='text')html += ''+v.message;
		if(v.type=='image')html += '<img class="msg-content-image" src="'+(v.message ? getImgUrl(v.message) : '')+'" style="max-width: 100px;" />';
		if(v.type=='sound')html += '<span class="mui-icon mui-icon-mic" style="font-size: 18px;font-weight: bold;"></span><span class="play-state">点击播放</span>';
		html += '</div><div class="msg-content-arrow"></div></div>';
		html += '<div class="mui-item-clear"></div></div>';
	});
	return html;	
}
/**
 * 读取正在聊天的消息
 */
function getChatingMessage(){
	$.ajax({
		type:"get",
		url:ApiRoot,
		dataType:'json',
		data:'m=chat&a=getChatingMessageOfGroup&uid='+uid+'&gid='+gid+'&maxid='+maxid,
		success:function(data){
//			console.log(JSON.stringify(data));
			var html = getChatHtml(data);
			if(data){
				$("#msg-list").append(html);
				messageGoBottom();
				loading();
			}
			updateNews();
		},
		error:function(e){
			updateNews();
			console.log(JSON.stringify(e));
		} 
	});
}

/**
 * 每秒读取一次
 */
function updateNews(){
	setTimeout(getChatingMessage,1000);
}

/**
 * 发送文字聊天消息
 * @param {Object} message 消息内容
 */
function sendMessageText(message){
	$.ajax({
		type:"get",
		url:ApiRoot,
		dataType:'json',
		data:'m=chat&a=sendMessageTextOfGroup&uid='+uid+'&gid='+gid+'&message='+message,
		success:function(data){
//			console.log(JSON.stringify(data));
			if(data>0){
				var html = '';
				html += '<div class="msg-item msg-item-self" msg-type="text" msg-content="'+message+'">';
				html += '<img class="msg-user-img self-avatar" src="'+(getStorage('lz_avatar') ? getImgUrl(getStorage('lz_avatar')) :'' )+'" alt="" />';
				html += '<div class="msg-content">';
				html += '<div class="msg-content-inner">';
				html += ''+message;
				html += '</div><div class="msg-content-arrow"></div></div>';
				html += '<div class="mui-item-clear"></div></div>';
				$("#msg-list").append(html);
				messageGoBottom();
				loading();
			}
		},
		error:function(e){
			console.log(JSON.stringify(e));
		} 
	});
}
/**
 * 发送文件消息
 * @param {Object} type 文件类型 image/sound
 */
var files=[];
function sendMessageFile(type,path){
	var server = ApiRoot+'?m=chat&a=sendMessageFileOfGroup&uid='+uid+'&gid='+gid+'&type='+type;
	if(files.length<=0){
		toast("没有添加上传文件！");
		return;
	}
//	showWaiting("开始上传",100000); 
	var html = '';
	html += '<div class="msg-item msg-item-self" msg-type="'+type+'" msg-content="'+path+'">';
	html += '<img class="msg-user-img self-avatar" src="'+(getStorage('lz_avatar') ? getImgUrl(getStorage('lz_avatar')) :'' )+'" alt="" />';
	html += '<div class="msg-content">';
	html += '<div class="msg-content-inner">';
	if(type=='image')html += '<span class="mui-spinner loading"></span><img class="msg-content-image" src="'+path+'" style="max-width: 100px;opacity: 0.6;" />';
	if(type=='sound')html += '<span class="mui-icon mui-icon-mic" style="font-size: 18px;font-weight: bold;"></span><span class="play-state">点击播放</span>';
	html += '</div><div class="msg-content-arrow"></div></div>';
	html += '<div class="mui-item-clear"></div></div>';
	$("#msg-list").append(html);
	messageGoBottom();
	var task=plus.uploader.createUpload(server,
		{method:"POST"},
		function(t,status){ //上传完成
			plus.nativeUI.closeWaiting();
			if(status==200){
				if(t.responseText>0){
					files=[];
//					toast("上传成功");
					loading();
					$(".mui-spinner").hide();
					$(".msg-content-image").css('opacity','1');
				}else{
					toast("上传失败："+status+t.responseText);
				}
			}else{
				toast("上传失败："+status+t.responseText);
			}
		}
	);
	for(var i=0;i<files.length;i++){
		var f=files[i];
		task.addFile(f.path,{key:f.name});
	}
	task.start();
}
//是消息列表滚动到底部位置
function messageGoBottom(){
	var div = document.getElementById('msg-list');
	div.scrollTop = div.scrollHeight;
}
/**
 * 初始化图片、录音文件 
 * 点击图片放大展示
 */
function loading(){//初始化图片、录音文件 
	var ui = {
		body: document.querySelector('body'),
		footer: document.querySelector('footer'),
		footerRight: document.querySelector('.footer-right'),
		footerLeft: document.querySelector('.footer-left'),
		btnMsgType: document.querySelector('#msg-type'),
		boxMsgText: document.querySelector('#msg-text'),
		boxMsgSound: document.querySelector('#msg-sound'),
		btnMsgImage: document.querySelector('#msg-image'),
		areaMsgList: document.querySelector('#msg-list'),
		boxSoundAlert: document.querySelector('#sound-alert'),
		h: document.querySelector('#h'),
		content: document.querySelector('.mui-content')
	};
	var msgItems = ui.areaMsgList.querySelectorAll('.msg-item');
	[].forEach.call(msgItems, function(item, index) {
		item.addEventListener('tap', function(event) {
			msgItemTap(item, event);
		}, false);
	});
	var imageViewer = new mui.ImageViewer('.msg-content-image', {
		dbl: false
	});
	imageViewer.findAllImage();
//	ui.areaMsgList.scrollTop = ui.areaMsgList.scrollHeight + ui.areaMsgList.offsetHeight;
}

/**
 * 播放录音消息
 * @param {Object} msgItem 录音文件DOM对象
 * @param {Object} event
 */
function msgItemTap(msgItem, event) {//播放录音
	var msgType = msgItem.getAttribute('msg-type');
	var msgContent = msgItem.getAttribute('msg-content')
	if (msgType == 'sound') {
		if(plus.os.name=='Android'){
			player = plus.audio.createPlayer(msgContent);
			var playState = msgItem.querySelector('.play-state');
			playState.innerText = '正在播放...';
			player.play(function() {
				playState.innerText = '点击播放';
			}, function(e) {
				playState.innerText = '点击播放';
			});
		}else{
			console.log(msgContent)
			var playState = msgItem.querySelector('.play-state');
			playState.innerText = '正在播放...';
			var f = msgContent.substr(msgContent.lastIndexOf('/')+1);
			if(msgContent.indexOf('_doc/')>=0){
				player = plus.audio.createPlayer(msgContent);
			}else{
				player = plus.audio.createPlayer('_doc/audios/'+f);
			}
			player.play(function() {
//				console.log('文:'+f+'已经存在，开始播放');
				playState.innerText = '点击播放';
			}, function(e) {
//				console.log('文件不存在，开始下载');
				var dtask = plus.downloader.createDownload( msgContent, {filename:'_doc/audios/'}, function ( d, status ) {
					// 下载完成
					if ( status == 200 ) { 
//						console.log( "下载成功: " + d.filename );
						player = plus.audio.createPlayer(d.filename);
						player.play(function() {
							playState.innerText = '点击播放';
						}, function(e) {
							playState.innerText = '点击播放';
						});
					} else {
						 toast( "下载失败，该文件已丢失"); 
					}  
				});
				dtask.start(); 
			});
		}
	}
};	
